////////////////////////////////////////////////////////
//                                                    //
//  Borland C++ hbOhbvMvO  //
//  ZPSאڃTvŒu                     //
//                                                    //
//                        Presented by Arata KAWAMURA //
//                                         2017.05.22.//
////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#define  MEM_SIZE 16000                                     // ̃TCY
#define  FFT_SIZE 512                                       // FFT_
#define  pw       1                                         // ZPSϊ̐Ûׂ

///////////////////////////////////////////////
//                                           //
//                                           //
//            FFT֐̍\z                  //
//                                           //
//                                           //
///////////////////////////////////////////////
static double Wr[FFT_SIZE+1],Wi[FFT_SIZE+1];                // FFT d
static double Fr[FFT_SIZE+1],Fi[FFT_SIZE+1],Xr[FFT_SIZE+1],Xi[FFT_SIZE+1]; //Ƌ
static double xin[FFT_SIZE+1],z[FFT_SIZE+1];                // FFT͂Əo
static double Xamp[FFT_SIZE+1];                             // UXyNg
static double Xphs[FFT_SIZE+1];                             // ʑXyNg
static double omega;                                        // FFTpg
static int    St,br[FFT_SIZE+1];                            // FFTXe[WԍCrbg]
static double s0[FFT_SIZE+1]={0};                           // [ʑM

void bitr( void );                                          // rbg]p֐̐錾
void fft ( void );                                          // FFT֐̐錾
void Wnk ( void );                                          // FFTo^tC(BF)Z̏d݊֐̐錾
void ifft( void );                                          // IFFT֐̐錾
void init( void );                                          // FFT֘Aϐ̏ݒ

///////////////////////////////////////////////
//                                           //
//                ݒ                   //
//                                           //
///////////////////////////////////////////////
void init(void){
    int i;
    St=log((double)FFT_SIZE)/log(2.0)+0.5;                  // FFTASY̒i̎Zo +0.5intւ̑Ή
    omega=2.0*M_PI/FFT_SIZE;
    bitr();Wnk();
}

void bitr( void ){                                          // rbg]
    int loop,i,j;
    br[0]=0;                                                // 0Ԗڂ0
    br[1]=FFT_SIZE/2;                                       // 1ԖڂN/2
    loop=1;
    for(j=0;j<St-1;j++){
        br[loop*2]=br[loop]/2;
        loop=loop*2;
        for(i=1;i<loop;i++){
            br[loop+i]=br[loop]+br[i];
        }
    }
}

void Wnk(void){                                            // ď݂vZ
    int i;
    for(i=0;i<FFT_SIZE/2;i++){
        Wr[i]=cos(omega*i);                                // dݎ
        Wi[i]=sin(omega*i);                                // d݋
    }
}

///////////////////////////////////////////////
//                                           //
//                   FFT                     //
//                                           //
///////////////////////////////////////////////
void fft( void ){
    int _2_s,_2_s_1,roop,l,m,p;
    int s,j,k;
    double Wxmr,Wxmi;
    for(j=0;j<FFT_SIZE;j++){                                // FFT͂̐ݒ
        Fr[br[j]]=xin[j];                                   // 
        Fi[br[j]]=0.0;
    }
    _2_s=1;
    for(s=1;s<=St;s++){                                     // Xe[WJԂ
        _2_s_1=_2_s;
        _2_s=_2_s*2;
        roop=FFT_SIZE/_2_s;
        for(j=0;j<roop;j++){                                // DFTJԂ
            for(k=0;k<_2_s_1;k++){                          // BFZJԂ
                l=_2_s*j+k;                                 // BF͔̏ԍ
                m=_2_s_1*(2*j+1)+k;                         // BF͔̉ԍ
                p=roop*k;                                   // ͂ւ̏dݔԍ
                Wxmr=Fr[m]*Wr[p]+Fi[m]*Wi[p];               // d݁~͂̎
                Wxmi=Fi[m]*Wr[p]-Fr[m]*Wi[p];               // d݁~͂̋
                Xr[m]=Fr[m]=Fr[l]-Wxmr;                     // BF̉o͂̎
                Xi[m]=Fi[m]=Fi[l]-Wxmi;                     // BF̉o͂̋
                Xr[l]=Fr[l]=Fr[l]+Wxmr;                     // BF̏o͂̎
                Xi[l]=Fi[l]=Fi[l]+Wxmi;                     // BF̏o͂̋
            }
        }
    }

    for(j=0;j<FFT_SIZE;j++){
        Xamp[j]=sqrt(Fr[j]*Fr[j]+Fi[j]*Fi[j]);              // UXyNg̎Zo
    }
}

///////////////////////////////////////////////
//                                           //
//                  IFFT                     //
//                                           //
///////////////////////////////////////////////
void ifft( void ){                                          // tt[Gϊ
    int _2_s,_2_s_1,roop,l,m,p;
    int s,j,k;
    double Wxmr,Wxmi;

    for(j=0;j<FFT_SIZE;j++){                                // tFFT͂̐ݒ
        Fr[br[j]]=Xr[j];
        Fi[br[j]]=Xi[j];
    }
    _2_s=1;
    for(s=1;s<=St;s++){                                     // Xe[WJԂ
        _2_s_1=_2_s;
        _2_s=_2_s*2;
        roop=FFT_SIZE/_2_s;
        for(j=0;j<roop;j++){                                // FFTJԂ
            for(k=0;k<_2_s_1;k++){                          // BFZJԂ
                l=_2_s*j+k;                                 // BF͔̏ԍ
                m=_2_s_1*(2*j+1)+k;                         // BF͔̉ԍ
                p=roop*k;                                   // ͂ւ̏dݔԍ
                Wxmr=Fr[m]*Wr[p]-Fi[m]*Wi[p];               // d݁~͂̎
                Wxmi=Fi[m]*Wr[p]+Fr[m]*Wi[p];               // d݁~͂̋
                z[m]=Fr[m]=Fr[l]-Wxmr;                      // BF̉o͂̎
                Fi[m]=Fi[l]-Wxmi;                           // BF̉o͂̋
                z[l]=Fr[l]=Fr[l]+Wxmr;                      // BF̏o͂̎
                Fi[l]=Fi[l]+Wxmi;                           // BF̏o͂̋
            }
        }
    }
}


///////////////////////////////////////////////
//                                           //
//                  ZPT                      //
//                                           //
///////////////////////////////////////////////
void zpt(void){
    int k;
    fft();
    for(k=0;k<FFT_SIZE;k++){
        if(Xr[k]!=0){
            Xphs[k]=atan2(Xi[k],Xr[k]);                     // ʑL^D-΂΂̃WAlD
        }
        Xr[k]=pow(Xamp[k], pw);                             // Upw[ʑMƂ
        Xi[k]=0;                                            // 0
    }
    ifft();                                                 // IFFTZPS쐬
    for(k=0;k<FFT_SIZE;k++){
        s0[k]=z[k]/FFT_SIZE;                                // s0ƂċL
    }
}
///////////////////////////////////////////////
//                                           //
//                  IZPT                     //
//                                           //
///////////////////////////////////////////////
void izpt(void){
    int k;
    for(k=0;k<FFT_SIZE;k++){
        xin[k]=s0[k];                                       // FFT͂ZPSƂ
    }
    fft();                                                  // ZPSUXyNg𓾂
   	for(k=0;k<FFT_SIZE;k++){
        if(Fr[k]<=0)Fr[k]=0;
        Xamp[k]=Fr[k]; 			//U̎Zo
    }
    for(k=0;k<FFT_SIZE;k++){
        Xr[k]=Xamp[k]*cos(Xphs[k]);                         // ʑƗZĎ
        Xi[k]=Xamp[k]*sin(Xphs[k]);                         // ʑƗZċ
    }
    ifft();                                                 // IFFTɂ莞ԗ̈M𓾂(z[n])
}


///////////////////////////////////////////////
//                                           //
//              C֐                   //
//                                           //
///////////////////////////////////////////////
int main(int argc, char **argv){
    ///////////////////////////////
    //                           //
    //  t@Cǂݏpϐ   //
    //                           //
    ///////////////////////////////
    FILE *f1, *f2;
    unsigned short tmp1;                                    // 2oCgϐ
    unsigned long  tmp2;                                    // 4oCgϐ
    int Fs;                                                 // ̓TvOg
    int ch;                                                 // ̓`l
    int len;                                                // ͐M̒
    
    char outname[256]={0};                                  // o̓t@C
    unsigned short channel;                                 // o̓`l
    unsigned short BytePerSample;                           // 1TṽoCg
    unsigned long  file_size;                               // o̓t@CTCY
    unsigned long  Fs_out;                                  // o̓TvOg
    unsigned long  BytePerSec;                              // 1b̃oCg
    unsigned long  data_len;                                // o͔g`̃Tv
    unsigned long  fmt_chnk    =16;                         // fmt`ÑoCg.PCM̏ꍇ16bit
    unsigned short BitPerSample=16;                         // 1Tṽrbg
    unsigned short fmt_ID      =1;                          // fmt ID. PCM̏ꍇ1


//************************************************************************//

    ///////////////////////////////
    //                           //
    //      Mpϐ       //
    //                           //
    ///////////////////////////////
    int      t      = 0;                                    // ̕ϐ
    long int t_out  = 0;                                    // Ivp̕ϐ
    int      add_len= 0;                                    // o͐MTv
    short    input, output;                                 // ǍݕϐƏoϐ
    double   s[MEM_SIZE+1]={0};                             // ̓f[^i[pϐ
    double   y[MEM_SIZE+1]={0};                             // o̓f[^i[pϐ

    long int l,i;                                           // FFTpϐ
    double   x[FFT_SIZE+1] ={0};                            // FFT̓
    double   x1[FFT_SIZE+1]={0};                            // t[Vtg͕̓ێp
    double   z1[FFT_SIZE+1]={0};                            // n[tI[o[bv̏o͕ێp

    ///////////////////////////////
    //                           //
    //      ϐ̏ݒ       //
    //                           //
    ///////////////////////////////

    init();                                                 // rbg]C݌W̌vZ
    l = 0;                                                  // FFTJnǗ

//************************************************************************//


    //////////////////////////////////////
    //                                  //
    // st@C̎gɊւx //
    //                                  //
    //////////////////////////////////////
    if( argc != 2 ){                                        // gp@Ԉꍇ̌x
        fprintf( stderr, "Usage: ./a input.wav \n" );
        exit(-1);
    }
    if( (f1 = fopen(argv[1], "rb")) == NULL ){              // o̓t@CJȂꍇ̌x
        fprintf( stderr, "Cannot open %s\n", argv[1] );
        exit(-2);
    }

    ////////////////////////////////////////////
    //                                        //
    //  wavet@C̃wb_ǂݍ  //
    //                                        //
    ////////////////////////////////////////////
    printf("Wave data is\n");
    fseek(f1, 22L, SEEK_SET);                               // `lʒuɈړ
    fread ( &tmp1, sizeof(unsigned short), 1, f1);          // `lǍ 2Byte
    ch=tmp1;                                                // ̓`l̋L^
    fread ( &tmp2, sizeof(unsigned long), 1, f1);           // TvOg̓Ǎ 4Byte
    Fs = tmp2;                                              // TvOg̋L^
    fseek(f1, 40L, SEEK_SET);                               // TvʒuɈړ
    fread ( &tmp2, sizeof(unsigned long), 1, f1);           // f[^̃Tv擾 4Byte
    len=tmp2/2/ch;                                          // ̒̋L^ (2Byte1Tv)

    printf("Channel       = %d ch\n",  ch);                 // ̓`l̕\
    printf("Sample rate   = %d Hz \n", Fs);                 // ̓TvOg̕\
    printf("Sample number = %d\n",     len);                // ͐M̒̕\

    //////////////////////////////////////
    //                                  //
    //     owavet@C̏       //
    //                                  //
    //////////////////////////////////////
    Fs_out        = Fs;                                     // o̓TvOgݒ
    channel       = ch;                                     // o̓`lݒ
    data_len      = channel*(len+add_len)*2;                // o̓f[^̒ = SByte (1Tv2Byte)
    file_size     = 36+data_len;                            // S̃t@CTCY
    BytePerSec    = Fs_out*channel*2;                       // 1b̃oCg
    BytePerSample = channel*2;                              // 1TṽoCg
    sscanf(argv[1],"%[^-^.]s", outname);                    // ̓t@C擾 (gqO)
    strcat(outname,"_output.wav");                          // outname="̓t@C_output.wav"
    f2=fopen(outname,"wb");                                 // o̓t@CI[vD݂Ȃꍇ͍쐬

    //////////////////////////////////////
    //                                  //
    //     o̓wb_񏑂       //
    //                                  //
    //////////////////////////////////////
    fprintf(f2, "RIFF");                                    // "RIFF"
    fwrite(&file_size,    sizeof(unsigned long ), 1, f2);   // t@CTCY
    fprintf(f2, "WAVEfmt ");                                // "WAVEfmt"
    fwrite(&fmt_chnk,     sizeof(unsigned long ), 1, f2);   // fmt_chnk=16 (rbg)
    fwrite(&fmt_ID,       sizeof(unsigned short), 1, f2);   // fmt ID=1 (PCM)
    fwrite(&channel,      sizeof(unsigned short), 1, f2);   // o̓`l
    fwrite(&Fs_out,       sizeof(unsigned long ), 1, f2);   // o͂̃TvOg
    fwrite(&BytePerSec,   sizeof(unsigned long ), 1, f2);   // 1b̃oCg
    fwrite(&BytePerSample,sizeof(unsigned short ),1, f2);   // 1TṽoCg
    fwrite(&BitPerSample, sizeof(unsigned short ),1, f2);   // 1Tṽrbg(16rbg)
    fprintf(f2, "data");                                    // "data"
    fwrite(&data_len,     sizeof(unsigned long ), 1, f2);   // o̓f[^̒

    printf("\nOutput WAVE data is\n");
    printf("Channel       = %d ch\n",  channel);            // o̓`l̕\
    printf("Sample rate   = %d Hz \n", Fs_out);             // o̓TvOg̕\
    printf("Sample number = %d\n",     data_len/ch/2);      // o͐M̒̕\

    ///////////////////////////////////
    //                               //
    //        C[v           //
    //                               //
    ///////////////////////////////////
    fseek(f1, 44L, SEEK_SET);                               // f[^JnʒuɈړ
    while(1){                                               // C[v
        if(fread( &input, sizeof(short), 1,f1) < 1){        //  input ɓǍ
            if( t_out > len+add_len ) break;                // [vI
            else input=0;                                   // [vpǍݏIȂ input=0
        }
        s[t] = input/32768.0;                               // ̍ől1Ƃ(K)


//************************************************************************//

        ////////////////////////////////////////////////////
        //                                                //
        //              Signal Processing                 //
        //                                                //
        //  ݎt̓ s[t] o y[t]    //
        //                                                //
        //   t0MEM_SIZE-1܂ł[v             //
        //                                                //
        ////////////////////////////////////////////////////

        x[l] = x1[l];                                       // FFT_SIZE/2܂ł̓͂x[l]Ɋi[
        x1[l]= x[FFT_SIZE/2+l]=s[t];                        // FFT_SIZE/2ȍ~̓͂x[l]Ɋi[
        y[t] = (z[l]+z1[l])/FFT_SIZE;                       // IFFTœo
        z1[l]= z[FFT_SIZE/2+l];                             // n[tI[o[bvpɏo͋L^

        if( l>=FFT_SIZE/2){                                 // t[ƂFFTs
            for(i=0;i<FFT_SIZE;i++){
                xin[i]=x[i]*0.5*(1.0-cos(2.0*M_PI*i/(double)(FFT_SIZE-1)));// ֐
            }
            zpt();                                          // [ʑϊ

            ////////////////////////////////////////////////////
            //                                                //
            //               [ʑM                 //
            //                                                //
            ////////////////////////////////////////////////////
            ////////////////////////////////////
            //  _̒lאڒlƒu  //
            ////////////////////////////////////
            s0[0]=s0[1];                                    // אڃTvŒu
            izpt();                                         // t[ʑϊ
            l=0;
        }
        l++;                                                // FFTp̎Ǘ

//************************************************************************//

//        y[t] = atan(y[t])/(M_PI/2.0);                       // Nbvh~
        output = y[t]*32767;                                // o͂𐮐
        fwrite(&output, sizeof(short), 1, f2);              // ʂ̏o
        if(ch==2){                                          // XeI͂̏ꍇ
            if(fread(&input, sizeof(short), 1, f1)<1) break;// Rch̃Jǂݍ
            fwrite(&output, sizeof(short), 1, f2);          // Rch(=Lch)
        }
        t=(t+1)%MEM_SIZE;                                   //  t ̍XV
        t_out++;                                            // [vǏv
    }
    fclose(f1);                                             // ̓t@C
    fclose(f2);                                             // o̓t@C
    return 0;                                               // C֐̏I
}
