////////////////////////////////////////////////////////
//                                                    //
//  Borland C++ A^CMvO        //
//  ZPS_Qڂ̐MŒu               //
//                                                    //
//                        Presented by Arata KAWAMURA //
//                                         2017.05.22.//
////////////////////////////////////////////////////////
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <windows.h>
#include <mmsystem.h>
#include <conio.h>

#define MEM_SIZE 16000                                               // ̃TCY
#define Fs       16000                                               // A^C̃TvOg
#define NUM_BUF  8                                                   // ێpobt@̐
#define BUF_SIZE 160                                                 // eobt@̃TCY
#define FFT_SIZE 512                                                 // FFT_
#define pw       1                                                   // ZPSϊ̐Ûׂ

///////////////////////////////////////////////
//                                           //
//                                           //
//            FFT֐̍\z                  //
//                                           //
//                                           //
///////////////////////////////////////////////
static double Wr[FFT_SIZE+1],Wi[FFT_SIZE+1];                         // FFT d
static double Fr[FFT_SIZE+1],Fi[FFT_SIZE+1],Xr[FFT_SIZE+1],Xi[FFT_SIZE+1]; //Ƌ
static double xin[FFT_SIZE+1],z[FFT_SIZE+1];                         // FFT͂Əo
static double Xamp[FFT_SIZE+1];                                      // UXyNg
static double Xphs[FFT_SIZE+1];                                      // ʑXyNg
static double omega;                                                 // FFTpg
static int    St,br[FFT_SIZE+1];                                     // FFTXe[WԍCrbg]
static double s0[FFT_SIZE+1]={0};                           // [ʑM

void bitr( void );                                                   // rbg]p֐̐錾
void fft ( void );                                                   // FFT֐̐錾
void Wnk ( void );                                                   // FFTo^tC(BF)Z̏d݊֐̐錾
void ifft( void );                                                   // IFFT֐̐錾
void init( void );                                                   // FFT֘Aϐ̏ݒ

///////////////////////////////////////////////
//                                           //
//                ݒ                   //
//                                           //
///////////////////////////////////////////////
void init(void){
    int i;
    St=log((double)FFT_SIZE)/log(2.0)+0.5;                           // FFTASY̒i̎Zo +0.5intւ̑Ή
    omega=2.0*M_PI/FFT_SIZE;
    bitr();Wnk();
}

void bitr( void ){                                                   // rbg]
    int loop,i,j;
    br[0]=0;                                                         // 0Ԗڂ0
    br[1]=FFT_SIZE/2;                                                // 1ԖڂN/2
    loop=1;
    for(j=0;j<St-1;j++){
        br[loop*2]=br[loop]/2;
        loop=loop*2;
        for(i=1;i<loop;i++){
            br[loop+i]=br[loop]+br[i];
        }
    }
}

void Wnk(void){                                                     // ď݂vZ
    int i;
    for(i=0;i<FFT_SIZE/2;i++){
        Wr[i]=cos(omega*i);                                         // dݎ
        Wi[i]=sin(omega*i);                                         // d݋
    }
}

///////////////////////////////////////////////
//                                           //
//                   FFT                     //
//                                           //
///////////////////////////////////////////////
void fft( void ){
    int _2_s,_2_s_1,roop,l,m,p;
    int s,j,k;
    double Wxmr,Wxmi;
    for(j=0;j<FFT_SIZE;j++){                                        // FFT͂̐ݒ
        Fr[br[j]]=xin[j];                                           // 
        Fi[br[j]]=0.0;
    }
    _2_s=1;
    for(s=1;s<=St;s++){                                             // Xe[WJԂ
        _2_s_1=_2_s;
        _2_s=_2_s*2;
        roop=FFT_SIZE/_2_s;
        for(j=0;j<roop;j++){                                        // DFTJԂ
            for(k=0;k<_2_s_1;k++){                                  // BFZJԂ
                l=_2_s*j+k;                                         // BF͔̏ԍ
                m=_2_s_1*(2*j+1)+k;                                 // BF͔̉ԍ
                p=roop*k;                                           // ͂ւ̏dݔԍ
                Wxmr=Fr[m]*Wr[p]+Fi[m]*Wi[p];                       // d݁~͂̎
                Wxmi=Fi[m]*Wr[p]-Fr[m]*Wi[p];                       // d݁~͂̋
                Xr[m]=Fr[m]=Fr[l]-Wxmr;                             // BF̉o͂̎
                Xi[m]=Fi[m]=Fi[l]-Wxmi;                             // BF̉o͂̋
                Xr[l]=Fr[l]=Fr[l]+Wxmr;                             // BF̏o͂̎
                Xi[l]=Fi[l]=Fi[l]+Wxmi;                             // BF̏o͂̋
            }
        }
    }

    for(j=0;j<FFT_SIZE;j++){
        Xamp[j]=sqrt(Fr[j]*Fr[j]+Fi[j]*Fi[j]);                      // UXyNg̎Zo
    }
}


///////////////////////////////////////////////
//                                           //
//                  IFFT                     //
//                                           //
///////////////////////////////////////////////
void ifft( void ){                                                  // tt[Gϊ
    int _2_s,_2_s_1,roop,l,m,p;
    int s,j,k;
    double Wxmr,Wxmi;

    for(j=0;j<FFT_SIZE;j++){                                        // tFFT͂̐ݒ
        Fr[br[j]]=Xr[j];
        Fi[br[j]]=Xi[j];
    }
    _2_s=1;
    for(s=1;s<=St;s++){                                             // Xe[WJԂ
        _2_s_1=_2_s;
        _2_s=_2_s*2;
        roop=FFT_SIZE/_2_s;
        for(j=0;j<roop;j++){                                        // FFTJԂ
            for(k=0;k<_2_s_1;k++){                                  // BFZJԂ
                l=_2_s*j+k;                                         // BF͔̏ԍ
                m=_2_s_1*(2*j+1)+k;                                 // BF͔̉ԍ
                p=roop*k;                                           // ͂ւ̏dݔԍ
                Wxmr=Fr[m]*Wr[p]-Fi[m]*Wi[p];                       // d݁~͂̎
                Wxmi=Fi[m]*Wr[p]+Fr[m]*Wi[p];                       // d݁~͂̋
                z[m]=Fr[m]=Fr[l]-Wxmr;                              // BF̉o͂̎
                Fi[m]=Fi[l]-Wxmi;                                   // BF̉o͂̋
                z[l]=Fr[l]=Fr[l]+Wxmr;                              // BF̏o͂̎
                Fi[l]=Fi[l]+Wxmi;                                   // BF̏o͂̋
            }
        }
    }
}

///////////////////////////////////////////////
//                                           //
//                  ZPT                      //
//                                           //
///////////////////////////////////////////////
void zpt(void){
    int k;
    fft();
    for(k=0;k<FFT_SIZE;k++){
        if(Xr[k]!=0){
            Xphs[k]=atan2(Xi[k],Xr[k]);                     // ʑL^D-΂΂̃WAlD
        }
        Xr[k]=pow(Xamp[k], pw);                             // Upw[ʑMƂ
        Xi[k]=0;                                            // 0
    }
    ifft();                                                 // IFFTZPS쐬
    for(k=0;k<FFT_SIZE;k++){
        s0[k]=z[k]/FFT_SIZE;                                // x0ƂċL
    }
}
///////////////////////////////////////////////
//                                           //
//                  IZPT                     //
//                                           //
///////////////////////////////////////////////
void izpt(void){
    int k;
    for(k=0;k<FFT_SIZE;k++){
        xin[k]=s0[k];                                       // FFT͂ZPSƂ
    }
    fft();                                                  // ZPSUXyNg𓾂
   	for(k=0;k<FFT_SIZE;k++){
        if(Fr[k]<=0)Fr[k]=0;
        Xamp[k]=Fr[k]; 			//U̎Zo
    }
    for(k=0;k<FFT_SIZE;k++){
        Xr[k]=Xamp[k]*cos(Xphs[k]);                         // ʑƗZĎ
        Xi[k]=Xamp[k]*sin(Xphs[k]);                         // ʑƗZċ
    }
    ifft();                                                 // IFFTɂ莞ԗ̈M𓾂(z[n])
}


///////////////////////////////////////////////
//                                           //
//              C֐                   //
//                                           //
///////////////////////////////////////////////
int main(void){
    /////////////////////////////////
    //                             //
    //  A^Co͗pϐ   //
    //                             //
    /////////////////////////////////
    char   key;                                                     // X[Ə̐ؑ֗pϐ
    int in1;                                                        // ̓obt@ԍ
    int out1;                                                       // o̓obt@ԍ
    int flag;                                                       // o͏Ԃ̃tO
    int n;                                                          // obt@p̎
    short in_buf[NUM_BUF][BUF_SIZE]={0};                            // ̓obt@
    WAVEHDR in_hdr[NUM_BUF];                                        // ̓obt@̃wb_
	HWAVEIN in_hdl = 0;                                             // (^)foCX̃nh
    short out_buf[NUM_BUF][BUF_SIZE]={0};                           // o̓obt@
    WAVEHDR out_hdr[NUM_BUF];                                       // o̓obt@̃wb_
    HWAVEOUT out_hdl = 0;                                           // o(Đ)foCX̃nh

    WAVEFORMATEX wave_format_ex = {WAVE_FORMAT_PCM,                 // PCM
                                 1,                                 // m
                                 Fs,                                // TvOg
                                 2*Fs,                              // 1b̉f[^TCYibytej
                                 2,                                 // f[^̍ŏPʁi2bytej
                                 16,                                // ʎqrbgi16bitj
                                 0                                  // IvṼTCYi0byte)
                                };


//************************************************************************//

    ///////////////////////////////
    //                           //
    //      Mpϐ       //
    //                           //
    ///////////////////////////////
    int t   = 0;                                                    // ͂̎
    int to  = 0;                                                    // o͂̎
    int hflg= 0;                                                    // fʂƏ̏ԃtO
    int i;                                                          // for[vpϐ
    double s[MEM_SIZE+1]={0};                                       // ̓f[^i[pϐ
    double y[MEM_SIZE+1]={0};                                       // o̓f[^i[pϐ
    
    long int l;                                                     // FFTpϐ
    double   x[FFT_SIZE+1] ={0};                                    // FFT̓
    double   x1[FFT_SIZE+1]={0};                                    // t[Vtg͕̓ێp
    double   z1[FFT_SIZE+1]={0};                                    // n[tI[o[bv̏o͕ێp

    int      pos;                                           // 2ڂ̎n_
    double   max,sc[FFT_SIZE+1]={0};                        // s[NTCXP[O֐

    ///////////////////////////////
    //                           //
    //       ϐ̏ݒ      //
    //                           //
    ///////////////////////////////

    init();                                                         // rbg]C݌W̌vZ
    l = 0;                                                          // FFTJnǗ

//************************************************************************//


    ///////////////////////////////////////
    //                                   //
    //    o̓foCX̃I[v       // 
    //                                   //
    ///////////////////////////////////////
    waveInOpen(&in_hdl, 0, &wave_format_ex, 0, 0, CALLBACK_NULL);   // (^)foCXI[v
    for (i = 0; i < NUM_BUF; i++){
        memset(&in_hdr[i], 0, sizeof(WAVEHDR));                     // S̓obt@
    }
    waveOutOpen(&out_hdl, 0, &wave_format_ex, 0, 0, CALLBACK_NULL); // o(Đ)foCXI[v
    waveOutPause(out_hdl);                                          // TEhfoCẌꎞ~
    for (i = 0; i < NUM_BUF; i++){                                  // So̓obt@
        memset(&out_hdr[i], 0, sizeof(WAVEHDR));
    }
    ///////////////////////////////////////
    //                                   //
    //    o̓obt@̏ݒ       // 
    //                                   //
    ///////////////////////////////////////
    for (i=0;i<NUM_BUF;i++){                                        // obt@̐JԂ
        out_hdr[i].lpData = (char *)out_buf[i];                     // o̓obt@f[^XV
        out_hdr[i].dwBufferLength = BUF_SIZE * 2;                   // o̓obt@TCYݒ
        out_hdr[i].dwFlags = 0;                                     // o̓tÕNA
        waveOutPrepareHeader(out_hdl, &out_hdr[i], sizeof(WAVEHDR));// o̓obt@bN
        waveOutWrite(out_hdl, &out_hdr[i], sizeof(WAVEHDR));        // o̓obt@o͑҂L[ɑM
        in_hdr[i].lpData = (char *)in_buf[i];                       // ̓obt@f[^̍XV
        in_hdr[i].dwBufferLength = BUF_SIZE * 2;                    // ̓obt@TCYݒ
        in_hdr[i].dwFlags = 0;                                      // ̓tÕNA
        waveInPrepareHeader(in_hdl, &in_hdr[i], sizeof(WAVEHDR));   // ̓obt@bN
        waveInAddBuffer(in_hdl, &in_hdr[i], sizeof(WAVEHDR));       // ̓obt@͑҂L[ɑM
    }
    waveOutRestart(out_hdl);                                        // o͊Jn
    waveInStart(in_hdl);                                            // ͊Jn

    in1  = 0;                                                       // ̓obt@ԍ̏
    out1 = 0;                                                       // o̓obt@ԍ̏
    flag = 0;                                                       // o͔tO0()Ƃ

    printf("[space]--> Through <=> Processing\n");                  // [space]ŏ؂ւ
    printf("[Enter]--> End\n");                                     // [Enter]ŏI
    printf("Through\n");                                            // fʂł邱Ƃ\


    ///////////////////////////////////
    //                               //
    //        C[v           //
    //                               //
    ///////////////////////////////////
    while (1){
        //////////////////////////
        //                      //
        //    o͏o    //
        //                      //
        //////////////////////////
        if (flag == 1){                                             // flag=1Ȃo͏
            if ((out_hdr[out1].dwFlags & WHDR_DONE) != 0){          // o̓obt@̃tO0łȂȂ珈s
                for (n = 0; n < BUF_SIZE; n++){                     // o͂BUF_SIZETvo
                    to=(to+1)%MEM_SIZE;                             // o͎̍XV
                    out_buf[out1][n] = y[to]*32768;                 // o̓f[^L^
                }
                waveOutUnprepareHeader(out_hdl, &out_hdr[out1], sizeof(WAVEHDR)); // o̓obt@N[Abv
                out_hdr[out1].lpData = (char *)out_buf[out1];       // o̓f[^XV
//                out_hdr[out1].dwBufferLength = BUF_SIZE * 2;        // o̓obt@TCYݒ
                out_hdr[out1].dwFlags = 0;                          // o̓obt@̃tO0ɂ
                waveOutPrepareHeader(out_hdl, &out_hdr[out1], sizeof(WAVEHDR));   // XVo̓obt@
                waveOutWrite(out_hdl, &out_hdr[out1], sizeof(WAVEHDR));// o͑҂L[ɏo̓obt@f[^𑗐M
                out1=(out1+1)%NUM_BUF;                              // o̓obt@ԍXV
                flag = 0;                                           // o̓tO flag=0 (͏) ɂ
            }
        }
        //////////////////////////
        //                      //
        //    ͓Ǎݏ    //
        //                      //
        //////////////////////////
        if ((in_hdr[in1].dwFlags & WHDR_DONE) != 0){                // ̓obt@̃tO0łȂȂ珈s
            waveInUnprepareHeader(in_hdl, &in_hdr[in1], sizeof(WAVEHDR)); // ^ς݂̓̓obt@I
            for (n = 0; n < BUF_SIZE; n++){                         // BUF_SIZETv̓͂Ǎ݁C
                t=(t+1)%MEM_SIZE;                                   // ͎̍XV
                s[t] = in_buf[in1][n]/32768.0;                      // ̓obt@f[^ǂݍ (K)
                if(t%8000==0)s[t]=s[t]+0.9;                         // ͂ɃmCYǉ
                y[t] = s[t];                                        // ó͂̑fʂ
                if(hflg!=0){                                        // ԃtO0ȊOȂMs


//************************************************************************//

            ////////////////////////////////////////////////////
            //                                                //
            //              Signal Processing                 //
            //                                                //
            //  ݎt̓ s[t] o y[t]    //
            //                                                //
            //   t0MEM_SIZE-1܂ł[v             //
            //                                                //
            ////////////////////////////////////////////////////

                    x[l] = x1[l];                                   // FFT_SIZE/2܂ł̓͂x[l]Ɋi[
                    x1[l]= x[FFT_SIZE/2+l]=s[t];                    // FFT_SIZE/2ȍ~̓͂x[l]Ɋi[
                    y[t] = (z[l]+z1[l])/FFT_SIZE;                   // IFFTœo
                    z1[l]= z[FFT_SIZE/2+l];                         // n[tI[o[bvpɏo͋L^

                    if( l>=FFT_SIZE/2){                             // t[ƂFFTs
                        for(i=0;i<FFT_SIZE;i++){
                            xin[i]=x[i]*0.5*(1.0-cos(2.0*M_PI*i/(double)FFT_SIZE));// ֐
                        }
                        zpt();                                      // [ʑϊ

                        ////////////////////////////////////////////////////
                        //                                                //
                        //               [ʑM                 //
                        //                                                //
                        ////////////////////////////////////////////////////
                        //////////////////
                        //  s[NT  //
                        //////////////////
                        max=0;
                        pos=0;
                        for(i=Fs/300;i<Fs/100;i++){                     // 60Hz`300HzŃs[NT
                            if(s0[i]>max){
                                max=s0[i];                              // s[NlXV
                                pos=i;                                  // s[NʒuXV
                            }
                        }
                        ////////////////////////
                        //  XP[O֐  //
                        ////////////////////////
                        sc[0]= 1.0+cos(2.0*M_PI*(pos)/(double)(FFT_SIZE-1));  // ֐̋t֐
                        if(sc[0]!=0){
                            sc[0]=1.0/sc[0];
                        }
                        ////////////////////////
                        //  1Tvu   //
                        ////////////////////////
                        s0[0] = sc[0] * s0[pos];                        // 2ڂ̎n_Ō_u
                    
                        izpt();                                     // t[ʑϊ
                        l=0;
                    }
                    l++;                                            // FFTp̎Ǘ

//************************************************************************//

//                    y[t]=atan(y[t])/(M_PI/2.0);                     // Nbvh~
                }
            }
            in_hdr[in1].dwFlags = 0;                                // ̓obt@̃tO0ɂ
            waveInPrepareHeader(in_hdl, &in_hdr[in1], sizeof(WAVEHDR));   // XV̓obt@
            waveInAddBuffer(in_hdl, &in_hdr[in1], sizeof(WAVEHDR)); // ͑҂L[ɓ̓obt@f[^𑗐M
            in1=(in1+1)%NUM_BUF;                                    // ̓obt@̍XV
            flag = 1;                                               // o̓tO flag=1 (o͏)ɂ
        }

        ////////////////////////////////////////////////////
        //                                                //
        //        L[{[h͂ɑ΂鏈̐ݒ        //
        //                                                //
        //                                                //
        //  [ftHgݒ]                              //
        //  EXy[XL[őfʂƐM؂ւ    //
        //  EEnterL[ŃvOI                   //
        //                                                //
        ////////////////////////////////////////////////////
        if (kbhit()){                                               // L[{[h͂
            key = getch();                                          // L[̃`FbN
            if (key == 32){                                         // Xy[XL[Ƃ
            	hflg=(hflg+1)%2;                                    // tOύX
                if(hflg==1) printf("Processing\n");                 // ł邱Ƃ\
                else        printf("Through\n");                    // fʂł邱Ƃ\
            }
            if (key == 13){                                         // EnterL[ꂽƂ
                waveInStop(in_hdl);                                 // ͂~
                for (i = 0; i < NUM_BUF; i++){                      // S̓obt@̃AbN
                    if ((in_hdr[i].dwFlags & WHDR_PREPARED) != 0){
                        waveInUnprepareHeader(in_hdl, &in_hdr[i], sizeof(WAVEHDR ));
                    }
                }
                waveInClose(in_hdl);                                // (^)foCX̃N[Y
                waveOutPause(out_hdl);                              // o͂~
                for (i = 0; i < NUM_BUF; i++){
                    if ((out_hdr[i].dwFlags & WHDR_PREPARED) != 0){ // So̓obt@̃AbN
                        waveOutUnprepareHeader(out_hdl, &out_hdr[i], sizeof(WAVEHDR));
                    }
                }
                waveOutClose(out_hdl);                              // o(Đ)foCX̃N[Y
                return 0;
            }
        }
    }                                                               //C[vI
}
